#include "messages.h"
#include "BasicMessages.h"
//#include "xmlParser.h"
#include <time.h>

/*extern "C" {
    #include "aes.h"
    #include "sha256.h"
}*/
#include "INTERFACE_TO_AES.h"

AnsiList  BufferedMessages;

#ifdef _WIN32
    #include <winsock.h>
#else
    #include <sys/types.h>
    #include <sys/socket.h>
    #include <netinet/in.h>
#endif


#define LESS_CHECKS_FOR_SPEED
/*
int DeSerializeBuffer(char *buffer, long size, AnsiString *Owner, long *message, AnsiString *Target, AnsiString *Value) {
    // OWNER poate avea maxim 256 octeti
    char *ptr=buffer;
    unsigned char owner_size=*(unsigned long *)buffer;
    buffer++;
    if (owner_size) {
        Owner->LoadBuffer(buffer, owner_size);
        buffer+=owner_size;
    }

    *message=*(long *)buffer;
    buffer+=sizeof(long);
    unsigned short target_size=*(unsigned short *)buffer;
    buffer+=sizeof(short);
    if (target_size) {
        Target->LoadBuffer(buffer, target_size);
        buffer+=target_size;
    }
    long last_size=size-(buffer-ptr);
    Value->LoadBuffer(buffer,last_size);
    return 1;
}


int SerializeBuffer(char **buffer, long *size, AnsiString *Owner, long message, AnsiString *Target, AnsiString *Value) {
    // OWNER poate avea maxim 256 octeti
    *size=sizeof(char)+Owner->Length()+sizeof(long)+sizeof(short)+Target->Length()+Value->Length();
    char *buf=new char[*size];
    *buffer=buf;

    *(unsigned char *)buf=(unsigned char)Owner->Length();
    buf+=sizeof(char);

    memcpy(buf, Owner->c_str(), Owner->Length());
    buf+=Owner->Length();

    *(long *)buf=message;
    buf+=sizeof(long);

    *(unsigned short *)buf=(unsigned short)Target->Length();
    buf+=sizeof(short);

    memcpy(buf, Target->c_str(), Target->Length());
    buf+=Target->Length();

    memcpy(buf, Value->c_str(), Value->Length());

    return 1;
}*/
//-----------------------------------------------------------------------------------
int DeSerializeBuffer(char *buffer, long size, AnsiString *Owner, long *message, AnsiString *Target, AnsiString *Value) {
    // OWNER poate avea maxim 256 octeti
    char *ptr=buffer;
    unsigned char owner_size=*(unsigned char *)buffer;
    buffer++;
    if (owner_size) {
        Owner->LoadBuffer(buffer, owner_size);
        buffer+=owner_size;
    } else
        *Owner=(char *)"";

    *message=ntohl(*(long *)buffer);
    buffer+=sizeof(long);
    unsigned short target_size=ntohs(*(unsigned short *)buffer);
    buffer+=sizeof(short);
    if (target_size) {
        Target->LoadBuffer(buffer, target_size);
        buffer+=target_size;
    } else
        *Target=(char *)"";

    long last_size=size-(buffer-ptr);
    Value->LoadBuffer(buffer,last_size);
    return 1;
}
//-----------------------------------------------------------------------------------
char *SerializeBuffer(char **buffer, long *size, AnsiString *Owner, long message, AnsiString *Target, AnsiString *Value, bool buferize, FILE **file_buffer, long *fsize) {
    // OWNER poate avea maxim 256 octeti
    long vsize=Value->Length();
    *fsize=0;
    FILE *in=NULL;
    *file_buffer=NULL;
    if ((message==MSG_REQUEST_FOR_FILE) && (vsize)) {
        vsize=0;
        in=fopen(Value->c_str(),"rb");
        if (in) {
            fseek(in,0,SEEK_END);
            if (buferize)
                vsize=ftell(in);
            else
                *fsize=ftell(in);
            fseek(in,0,SEEK_SET);
        }    
    }

    *size=sizeof(char)+Owner->Length()+sizeof(long)+sizeof(short)+Target->Length()+vsize;
    char *ptr=new char[*size+sizeof(long)];
    // add the file buffer, if we have one
    *(long *)ptr=htonl(*size+*fsize);
    char *buf=ptr+sizeof(long);//new char[*size];
    *buffer=buf;

    /*char *ptr=new char[*size];
    char *buf=ptr;
    *buffer=buf;*/

    *(unsigned char *)buf=(unsigned char)Owner->Length();
    buf+=sizeof(char);

    memcpy(buf, Owner->c_str(), Owner->Length());
    buf+=Owner->Length();

    *(long *)buf=htonl(message);
    buf+=sizeof(long);

    *(unsigned short *)buf=htons((unsigned short)Target->Length());
    buf+=sizeof(short);

    memcpy(buf, Target->c_str(), Target->Length());
    buf+=Target->Length();

    if (in) {
        if (buferize) {
            int r=0;
            do {
                r=fread(buf,1,RBUF_SIZE,in);
                if (r>0)
                    buf+=r;
            } while (r==RBUF_SIZE);
            fclose(in);
        } else
            *file_buffer=in;
    } else
        memcpy(buf, Value->c_str(), Value->Length());
    return ptr;
}
//-----------------------------------------------------------------------------------


//-----------------------------------------------------------------------------------
/*unsigned long AES_encrypt(char *in_buffer, unsigned long in_buffer_size, char *out_buffer, unsigned long out_buffer_size, char *key, unsigned long key_size) {
	unsigned char IV[16];
	unsigned char digest[32];
	unsigned char k_ipad[64];
	unsigned char k_opad[64];
	unsigned char buffer[1024];
        char *output_ptr=out_buffer;
	char *input_ptr=in_buffer;
	int i,n;

	aes_context aes_ctx;
	sha256_context sha_ctx;

	time_t cur_time = time( NULL );
        for( i = 0; i < 8; i++ )
            buffer[i    ] = (unsigned char) ( cur_time >> (i * 8) );

        for( i = 0; i < 8; i++ )
            buffer[i + 8] = (unsigned char) ( in_buffer_size >> (i * 8) );

        sha256_starts( &sha_ctx );
        sha256_update( &sha_ctx, buffer, 16 );
        sha256_update( &sha_ctx, buffer, 16 );
        //sha256_update( &sha_ctx, (unsigned char *) argv[2], strlen( argv[2] ) );
        sha256_finish( &sha_ctx, digest );

        memcpy( IV, digest, 16 );
	int lastn=(int) (in_buffer_size & 0x0F );

        IV[15] &= 0xF0;
        IV[15] |= lastn;

        memcpy(output_ptr,IV,16);
        output_ptr+=16;

        memset( digest, 0,  32 );
        memcpy( digest, IV, 16 );

	for( i = 0; i < 8192; i++ ) {
            sha256_starts( &sha_ctx );
            sha256_update( &sha_ctx, digest, 32 );
            sha256_update( &sha_ctx, (unsigned char *) key, key_size);
            sha256_finish( &sha_ctx, digest );
        }

	aes_set_key( &aes_ctx, digest, 256 );
        memset( k_ipad, 0x36, 64 );
        memset( k_opad, 0x5C, 64 );

        for( i = 0; i < 32; i++ ) {
            k_ipad[i] ^= digest[i];
            k_opad[i] ^= digest[i];
        }
        // encrypt and write the ciphertext 
        sha256_starts( &sha_ctx );
        sha256_update( &sha_ctx, k_ipad, 64 );
        
	for(long offset = 0; offset < in_buffer_size; offset += 16 ) {
            n = ( in_buffer_size - offset > 16 ) ? 16 : (int)
                ( in_buffer_size - offset );

            memcpy(buffer, input_ptr, n);
            input_ptr+=n;

            for( i = 0; i < 16; i++ )
                buffer[i] ^= IV[i];

            aes_encrypt(   &aes_ctx, buffer, buffer );
            sha256_update( &sha_ctx, buffer, 16 );

            memcpy(output_ptr, buffer, 16);
            output_ptr+=16;

            memcpy( IV, buffer, 16 );
        }
        sha256_finish( &sha_ctx, digest );

#ifndef LESS_CHECKS_FOR_SPEED
        sha256_starts( &sha_ctx );
        sha256_update( &sha_ctx, k_opad, 64 );
        sha256_update( &sha_ctx, digest, 32 );
        sha256_finish( &sha_ctx, digest );

	memcpy(output_ptr,digest,32);
	output_ptr+=32;	
#endif

	return (unsigned long)output_ptr-(unsigned long)out_buffer;
}
//-----------------------------------------------------------------------------------
unsigned long AES_decrypt(char *in_buffer, unsigned long in_buffer_size, char *out_buffer, unsigned long out_buffer_size, char *key, unsigned long key_size) {
    unsigned char IV[16];
    unsigned char tmp[16];
    unsigned char digest[32];
    unsigned char k_ipad[64];
    unsigned char k_opad[64];
    unsigned char buffer[1024];
    char *output_ptr=out_buffer;
    char *input_ptr=in_buffer;
    int i,n, lastn;

	aes_context aes_ctx;
	sha256_context sha_ctx;

#ifndef LESS_CHECKS_FOR_SPEED
	// buffer prea mic ca sa fie criptat ...
	if (in_buffer_size<48)
		return 0;
#else
	// buffer prea mic ca sa fie criptat ...
	if (in_buffer_size<16)
		return 0;
#endif
	// nu este multiplu de 16
	if ((in_buffer_size & 0x0F) !=0)
		return 0;
#ifndef LESS_CHECKS_FOR_SPEED
	in_buffer_size -= (16+32);
#else
	in_buffer_size -= 16;
#endif

	memcpy(IV, input_ptr, 16);
	input_ptr+=16;

	lastn = IV[15] & 0x0F;

        memset( digest, 0,  32 );
        memcpy( digest, IV, 16 );	

        for( i = 0; i < 8192; i++ ) {
            sha256_starts( &sha_ctx );
            sha256_update( &sha_ctx, digest, 32 );
            sha256_update( &sha_ctx, (unsigned char *) key, key_size);
            sha256_finish( &sha_ctx, digest );
        }

	aes_set_key( &aes_ctx, digest, 256 );
        memset( k_ipad, 0x36, 64 );
        memset( k_opad, 0x5C, 64 );
        for( i = 0; i < 32; i++ ) {
            k_ipad[i] ^= digest[i];
            k_opad[i] ^= digest[i];
        }

        sha256_starts( &sha_ctx );
        sha256_update( &sha_ctx, k_ipad, 64 );

        for(long offset = 0; offset < in_buffer_size; offset += 16 ) {
            memcpy(buffer, input_ptr, 16);
	    input_ptr+=16;

            memcpy( tmp, buffer, 16 );
            sha256_update( &sha_ctx, buffer, 16 );
            aes_decrypt(   &aes_ctx, buffer, buffer );
            for( i = 0; i < 16; i++ )
                buffer[i] ^= IV[i];
            memcpy( IV, tmp, 16 );
            n = ( lastn > 0 && offset == in_buffer_size - 16 )
                ? lastn : 16;

            memcpy(output_ptr,buffer,n);
            output_ptr+=n;
        }

        sha256_finish( &sha_ctx, digest );

#ifndef LESS_CHECKS_FOR_SPEED
        sha256_starts( &sha_ctx );
        sha256_update( &sha_ctx, k_opad, 64 );
        sha256_update( &sha_ctx, digest, 32 );
        sha256_finish( &sha_ctx, digest );

	memcpy(buffer, input_ptr, 32);
	input_ptr+=32;

	if (memcmp(digest, buffer, 32) != 0)
           return 0;
#endif

	return (unsigned long)output_ptr-(unsigned long)out_buffer;
}
*/
//-----------------------------------------------------------------------------------
unsigned long AES_encrypt(char *in_buffer, unsigned long in_buffer_size, char *out_buffer, unsigned long out_buffer_size, char *key, unsigned long key_size) {
	if (!En_inited)
		encrypt_init(key,key_size);

	return encrypt(in_buffer,in_buffer_size,out_buffer,out_buffer_size);
}
//-----------------------------------------------------------------------------------
unsigned long AES_decrypt(char *in_buffer, unsigned long in_buffer_size, char *out_buffer, unsigned long out_buffer_size, char *key, unsigned long key_size) {
	if (!Dec_inited)
		decrypt_init(key,key_size);

	return decrypt(in_buffer,in_buffer_size,out_buffer,out_buffer_size);
}
//-----------------------------------------------------------------------------------
/*
AnsiString remove_ampersands(AnsiString message_data) {
	int len=message_data.Length();
	AnsiString parsed="\"";

	parsed+=(char *)toXMLString(message_data.c_str());
	parsed+="\"";
	return parsed;
}*/
//-----------------------------------------------------------------------------------
#include <iostream>
int send_message(AnsiString SENDER_NAME, long MESSAGE_ID,  AnsiString MESSAGE_TARGET, AnsiString MESSAGE_DATA, SOCKET CLIENT_SOCKET, char *REMOTE_PUBLIC_KEY, PROGRESS_API notify_parent, bool idle_call) {

        /*AnsiString message_data;

        AnsiString SERVER_QUERY;
        //SERVER_QUERY    =   (char *)"<?xml version=\"1.0\"><ConceptXMLDataExchangeDocument><Message _OWNER=\"";
        SERVER_QUERY    =   (char *)"<Message _OWNER=";
        SERVER_QUERY    +=  remove_ampersands(SENDER_NAME);
        SERVER_QUERY    +=  (char *)" _ID=";
        SERVER_QUERY    +=  AnsiString(MESSAGE_ID);
        SERVER_QUERY    +=  (char *)" _TARGET=";
        SERVER_QUERY    +=  remove_ampersands(MESSAGE_TARGET);
        SERVER_QUERY    +=  (char *)" _DATA=";
        SERVER_QUERY    +=  remove_ampersands(MESSAGE_DATA);
        SERVER_QUERY    +=  (char *)" />";
        //SERVER_QUERY    +=  (char *)" /></ConceptXMLDataExchangeDocument>";*/

	    INTEGER res=0;
        char *buffer=0;
        long in_content_size=0;
        FILE *in=0;
        long file_buffer_size=0;
        bool buferize=REMOTE_PUBLIC_KEY ? true : false;
        char *base_ptr=SerializeBuffer(&buffer, &in_content_size, &SENDER_NAME, MESSAGE_ID, &MESSAGE_TARGET, &MESSAGE_DATA, buferize, &in, &file_buffer_size);
        long size_n;

        if (REMOTE_PUBLIC_KEY)  {
            // criptez query-ul ...
            int out_content_size=(in_content_size/16+1)*16+5;//(((in_content_size / 48) + 1) * 64) + 256;
            char *out_content=new char[out_content_size];

            int encrypt_result = AES_encrypt(   buffer, in_content_size,
                                                out_content, out_content_size,
                                                REMOTE_PUBLIC_KEY, /*strlen(REMOTE_PUBLIC_KEY)*/16 );
            if (!encrypt_result) {
                    delete[] out_content;
                    return 0;
            }

            long size=encrypt_result;
            size_n=htonl(size);

            send(CLIENT_SOCKET,(char *)&size_n, sizeof(long), 0);

            //----------------------------------------//
            if ((size >= BIG_MESSAGE) && (notify_parent)) {
                // notify big message !
                notify_parent(-1,"Sending data",idle_call);
                int chunks=size/CHUNK_SIZE;
                if (size%CHUNK_SIZE)
                    chunks++;
                for (int i=0;i<chunks;i++) {
                    int chunk_size=(i<chunks-1) ? CHUNK_SIZE : size%CHUNK_SIZE;
                    res=send(CLIENT_SOCKET,out_content+(i*CHUNK_SIZE), chunk_size, 0);
                    if (res!=chunk_size) {
                        notify_parent(-1,"Error in sending data",idle_call);
                        break;
                    }
                    notify_parent((int)(((double)(i*CHUNK_SIZE+res)/size)*100),0,idle_call);
                }
                notify_parent(101,0,idle_call);
                // done big message !
            } else
                res=send(CLIENT_SOCKET,out_content, size, 0);
            delete[] out_content;
        } else {

            // trimit dimensiunea mai intai ...
            size_n=htonl(in_content_size+file_buffer_size);
            send(CLIENT_SOCKET,(char *)&size_n, sizeof(long), 0);
            bool big_message=false;
            int total_sent=0;
            if ((in_content_size+file_buffer_size >= BIG_MESSAGE) && (notify_parent)) {
                // notify big message !
                big_message=true;
                notify_parent(-1,"Sending data",idle_call);
                int chunks=in_content_size/CHUNK_SIZE;
                if (in_content_size%CHUNK_SIZE)
                    chunks++;
                for (int i=0;i<chunks;i++) {
                    int chunk_size=(i<chunks-1) ? CHUNK_SIZE : in_content_size%CHUNK_SIZE;
                    res=send(CLIENT_SOCKET,buffer+(i*CHUNK_SIZE), chunk_size, 0);
                    if (res!=chunk_size) {
                        notify_parent(-1,"Error in sending data",idle_call);
                        if (in) {
                            fclose(in);
                            in=0;
                        }
                        break;
                    }
                    total_sent=i*CHUNK_SIZE+res;
                    notify_parent((int)(((double)(total_sent)/(in_content_size+file_buffer_size))*100),0,idle_call);
                }
                if (!in)
                    notify_parent(101,0,idle_call);
                // done big message !
            } else
                res=send(CLIENT_SOCKET,buffer, in_content_size, 0);

            if (in) {
                int r=0;
                char *file_buf=new char[RBUF_SIZE];
                int chunk_size=0;
                do {
                    chunk_size=fread(file_buf,1,RBUF_SIZE,in);
                    if (chunk_size>0) {
                        res=send(CLIENT_SOCKET, file_buf, chunk_size, 0);
                        if (res!=chunk_size) {
                            if (big_message)
                                notify_parent(-1,"Error in sending data",idle_call);
                            break;
                        }
                        total_sent+=res;
                        if (big_message)
                            notify_parent((int)(((double)(total_sent)/(in_content_size+file_buffer_size))*100),0,idle_call);
                    }
                } while (chunk_size==RBUF_SIZE);
                delete[] file_buf;
                fclose(in);
                in=NULL;
                if (big_message)
                    notify_parent(101,0,idle_call);
            }
        }
		if (base_ptr)
			delete[] base_ptr;
		// BUG: buffer=base_ptr+sizeof(long). Cannot delete buffer !
        //delete[] buffer;
        return 0;
}
//---------------------------------------------------------------------------
int get_message(TParameters *PARAM, SOCKET CLIENT_SOCKET, char *LOCAL_PRIVATE_KEY, PROGRESS_API notify_parent, bool idle_call) {
        long size=0;
        int received=0;
        int result=0;
        int rec_count=0;
        char *buffer=0;
        char *output=0;

		if (BufferedMessages.Count()) {
			TParameters *clone=(TParameters *)BufferedMessages.Remove(0);
			PARAM->Sender=clone->Sender;
			PARAM->ID=clone->ID;
			PARAM->Target=clone->Target;
			PARAM->Value=clone->Value;
			//PARAM->Owner=clone->Owner;
			delete clone;
			return 1;
		}

        do {
	        received=recv(CLIENT_SOCKET,(char *)&size+rec_count,sizeof(long)-rec_count,0);
            rec_count+=received;
        } while ((rec_count<sizeof(long)) && (received>0));
        size=ntohl(size);
        if (received<=0) {
            return 0;
        }
		
        if (size)
           buffer=new char[size+1];

        //----------------------------------------//
        if ((size >= BIG_MESSAGE) && (notify_parent)) {
            // notify big message !
            notify_parent(-1,"Receiving data",idle_call);
        }
        //----------------------------------------//
        rec_count=0;
        do {
            received=recv(CLIENT_SOCKET,buffer+rec_count,size-rec_count,0);
            rec_count+=received;

            if ((size >= BIG_MESSAGE) && (notify_parent)) {
                notify_parent((int)(((double)rec_count/size)*100),0,idle_call);
            }
        } while ((received>0) && (rec_count<size));

        if ((size >= BIG_MESSAGE) && (notify_parent)) {
            notify_parent(101,0,idle_call);
            // done big message !
        }

	    if (received<=0) {
           if (buffer)
	            delete[] buffer;
           return 0;
        }

        char *out_content=0;

        if (LOCAL_PRIVATE_KEY)  {
            out_content=new char[size*2];
            buffer[size]=0;
            int decrypt_result = AES_decrypt(   buffer, size,
                                                out_content, size,
                                                LOCAL_PRIVATE_KEY, /*strlen(LOCAL_PRIVATE_KEY)*/16 );
            out_content[decrypt_result]=0;
            if (!decrypt_result) {
                delete[] out_content;
                //return (void *)"get_message: <<RSA_decrypt>> error decrypting message.";
                out_content=0;
                //out_content=buffer;
            } else
                size=decrypt_result;
        }/* else
            out_content=buffer;*/

        long MSG_ID;
        if (out_content)
            DeSerializeBuffer(out_content, size, &PARAM->Sender, &MSG_ID, &PARAM->Target, &PARAM->Value);
        else
            DeSerializeBuffer(buffer, size, &PARAM->Sender, &MSG_ID, &PARAM->Target, &PARAM->Value);

        PARAM->ID=MSG_ID;

        if (out_content)
                delete[] out_content;

        if (buffer)
	            delete[] buffer;

        return size;
}
//---------------------------------------------------------------------------
int have_messages(SOCKET CLIENT_SOCKET) {
    struct timeval timeout;
    timeout.tv_sec = 0;
    timeout.tv_usec = 100000;
    fd_set socks;

    int sel_val;

    FD_ZERO(&socks);
    FD_SET(CLIENT_SOCKET,&socks);
    sel_val=select(FD_SETSIZE, &socks, 0, 0, &timeout);

    return (sel_val>0);
}
//---------------------------------------------------------------------------
int wait_message(TParameters *PARAM, long MESSAGE_ID, SOCKET CLIENT_SOCKET, char *LOCAL_PRIVATE_KEY, PROGRESS_API notify_parent) {
	int res=0;
	do {
		res=get_message(PARAM, CLIENT_SOCKET, LOCAL_PRIVATE_KEY, notify_parent);
        if (res<=0)
            break;
		if ((PARAM) && (PARAM->ID==MESSAGE_ID))
			return res;
		else {
			TParameters *clone=new TParameters;
			clone->Sender=PARAM->Sender;
			clone->ID=PARAM->ID;
			clone->Target=PARAM->Target;
			clone->Value=PARAM->Value;
			clone->Owner=PARAM->Owner;

			BufferedMessages.Add(clone, DATA_MESSAGE);
		}
	} while (res>0);
	return res;
}
//---------------------------------------------------------------------------
